/**
 * @file
 * Initialize history.back logic.
 */

(function ($, Drupal) {

  'use strict';

  Drupal.behaviors.previewerRefresh = {

    enabled: true,
    attach: function (context) {
      $('.js-previewerRefresh', context).once('previewerRefresh').each(function() {
        var $previewerRefreshButton = $(this);
        var $form = $previewerRefreshButton.closest('form');

        $form.on('formUpdated', (function(event) {
          if (!Drupal.behaviors.previewerRefresh.enabled) return;
          if ($('.js-offCanvasPreviewer').length === 0) return;

          Drupal.behaviors.previewerRefresh.enabled = false;
          $previewerRefreshButton.trigger('previewerRefreshSubmit');
          setTimeout(() => Drupal.behaviors.previewerRefresh.enabled = true, 1500);
        }));

        $previewerRefreshButton.on('previewerRefresh', function(event, data) {
          var $offCanvasPreviewer = $('.js-offCanvasPreviewerIframe');
          try {
            var $offCanvasPreviewerIframe = $offCanvasPreviewer[0];
            let scrollTop = $offCanvasPreviewerIframe.contentDocument.documentElement.scrollTop;
            $offCanvasPreviewerIframe.src += '';
            $offCanvasPreviewerIframe.onload = function () {
              $offCanvasPreviewerIframe.contentDocument.documentElement.scrollTop = scrollTop;
            }
          }
          catch(err) {
            $offCanvasPreviewer.replaceWith(data.content);
          }
        });
      });
    }
  };

}(jQuery, Drupal));
